diff --git a/vdsm/storage/iscsi.py b/vdsm/storage/iscsi.py
index a8a1e4f..5649f79 100644
--- a/vdsm/storage/iscsi.py
+++ b/vdsm/storage/iscsi.py
@@ -69,15 +69,29 @@ def getDevIscsiInfo(dev):
 
 def getSessionInfo(sessionID):
     sessionName = "session%d" % sessionID
+    connectionName = "connection%d:0" % sessionID
     sessionDir = glob.glob("/sys/devices/platform/host*/%s/" % sessionName)
-    if len(sessionDir) == 0:
-        raise OSError(errno.ENOENT, "No such session")
+    if len(sessionDir) > 0:
+        sessionDir = sessionDir[0]
+        iscsi_session = os.path.join(sessionDir, "iscsi_session", sessionName)
 
-    sessionDir = sessionDir[0]
+        if not os.path.exists(iscsi_session):
+            raise OSError(errno.ENOENT, "No such session")
 
-    iscsi_session = os.path.join(sessionDir, "iscsi_session", sessionName)
-    if not os.path.exists(iscsi_session):
-        raise OSError(errno.ENOENT, "No such session")
+        conn_pattern = os.path.join(sessionDir, "connection*")
+        try:
+            connectiondir = glob.glob(conn_pattern)[0]
+        except IndexError:
+            raise OSError(errno.ENOENT, "No such session")
+
+        connection = os.path.basename(connectiondir)
+        iscsi_connection = os.path.join(connectiondir, "iscsi_connection", connection)
+
+    else:
+	iscsi_session = "/sys/class/iscsi_session/%s/" % sessionName
+	iscsi_connection = "/sys/class/iscsi_connection/%s/" % connectionName
+	if not os.path.isdir(iscsi_session) or not os.path.isdir(iscsi_connection):
+	    raise OSError(errno.ENOENT, "No such session")
 
     targetname = os.path.join(iscsi_session, "targetname")
     iface = os.path.join(iscsi_session, "ifacename")
@@ -86,14 +100,6 @@ def getSessionInfo(sessionID):
     user = os.path.join(iscsi_session, "username")
     passwd = os.path.join(iscsi_session, "password")
 
-    conn_pattern = os.path.join(sessionDir, "connection*")
-    try:
-        connectiondir = glob.glob(conn_pattern)[0]
-    except IndexError:
-        raise OSError(errno.ENOENT, "No such session")
-
-    connection = os.path.basename(connectiondir)
-    iscsi_connection = os.path.join(connectiondir, "iscsi_connection", connection)
     paddr = os.path.join(iscsi_connection, "persistent_address")
     pport = os.path.join(iscsi_connection, "persistent_port")
 
